ovirt_vmpool – Module to manage VM pools in oVirt/RHV — Ansible Documentation

- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# ovirt_vmpool – Module to manage VM pools in oVirt/RHV

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Module to manage VM pools in oVirt/RHV.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.7
- ovirt-engine-sdk-python >= 4.3.0

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
auth dictionary / required |  | Dictionary with values needed to create HTTP/HTTPS connection to oVirt:
| ca_file string |  | A PEM file containing the trusted CA certificates. The certificate presented by the server will be verified using these CA certificates. If `ca_file` parameter is not set, system wide CA certificate store is used. Default value is set by `OVIRT_CAFILE` environment variable.
| headers dictionary |  | Dictionary of HTTP headers to be added to each API call.
| hostname string |  | A string containing the hostname of the server, usually something like `server.example.com`. Default value is set by `OVIRT_HOSTNAME` environment variable. Either `url` or `hostname` is required.
| insecure boolean | Choices: no yes | A boolean flag that indicates if the server TLS certificate and host name should be checked.
| kerberos boolean | Choices: no yes | A boolean flag indicating if Kerberos authentication should be used instead of the default basic authentication.
| password string / required |  | The password of the user. Default value is set by `OVIRT_PASSWORD` environment variable.
| token string |  | Token to be used instead of login with username/password. Default value is set by `OVIRT_TOKEN` environment variable.
| url string |  | A string containing the API URL of the server, usually something like `https://server.example.com/ovirt-engine/api`. Default value is set by `OVIRT_URL` environment variable. Either `url` or `hostname` is required.
| username string / required |  | The name of the user, something like admin@internal. Default value is set by `OVIRT_USERNAME` environment variable.
cluster - |  | Name of the cluster, where VM pool should be created.
comment - |  | Comment of the Virtual Machine pool.
description - |  | Description of the VM pool.
fetch_nested boolean | Choices: no yes | If True the module will fetch additional data from the API. It will fetch IDs of the VMs disks, snapshots, etc. User can configure to fetch other attributes of the nested entities by specifying `nested_attributes`.
id - added in 2.8 |  | ID of the vmpool to manage.
name - / required |  | Name of the VM pool to manage.
nested_attributes list |  | Specifies list of the attributes which should be fetched from the API. This parameter apply only when `fetch_nested` is true.
poll_interval integer | Default: 3 | Number of the seconds the module waits until another poll request on entity status is sent.
prestarted - |  | Number of pre-started VMs defines the number of VMs in run state, that are waiting to be attached to Users. Default value is set by engine.
state - | Choices: present ← absent | Should the VM pool be present/absent. Note that when `state` is absent all VMs in VM pool are stopped and removed.
template - |  | Name of the template, which will be used to create VM pool.
timeout integer | Default: 180 | The amount of time in seconds the module should wait for the instance to get into desired state.
type - | Choices: manual automatic | Type of the VM pool. Either manual or automatic. `manual` - The administrator is responsible for explicitly returning the virtual machine to the pool. The virtual machine reverts to the original base image after the administrator returns it to the pool. `Automatic` - When the virtual machine is shut down, it automatically reverts to its base image and is returned to the virtual machine pool. Default value is set by engine.
vm dictionary added in 2.9 |  | For creating vm pool without editing template. Note: You can use `vm` only for creating vm pool.
| cloud_init - |  | Dictionary with values for Unix-like Virtual Machine initialization using cloud init. `host_name` - Hostname to be set to Virtual Machine when deployed. `timezone` - Timezone to be set to Virtual Machine when deployed. `user_name` - Username to be used to set password to Virtual Machine when deployed. `root_password` - Password to be set for user specified by `user_name` parameter. `authorized_ssh_keys` - Use this SSH keys to login to Virtual Machine. `regenerate_ssh_keys` - If True SSH keys will be regenerated on Virtual Machine. `custom_script` - Cloud-init script which will be executed on Virtual Machine when deployed. This is appended to the end of the cloud-init script generated by any other options. `dns_servers` - DNS servers to be configured on Virtual Machine. `dns_search` - DNS search domains to be configured on Virtual Machine. `nic_boot_protocol` - Set boot protocol of the network interface of Virtual Machine. Can be one of `none`, `dhcp` or `static`. `nic_ip_address` - If boot protocol is static, set this IP address to network interface of Virtual Machine. `nic_netmask` - If boot protocol is static, set this netmask to network interface of Virtual Machine. `nic_gateway` - If boot protocol is static, set this gateway to network interface of Virtual Machine. `nic_name` - Set name to network interface of Virtual Machine. `nic_on_boot` - If True network interface will be set to start on boot.
| comment - |  | Comment of the Virtual Machine.
| memory - |  | Amount of memory of the Virtual Machine. Prefix uses IEC 60027-2 standard (for example 1GiB, 1024MiB). Default value is set by engine.
| memory_guaranteed - |  | Amount of minimal guaranteed memory of the Virtual Machine. Prefix uses IEC 60027-2 standard (for example 1GiB, 1024MiB). `memory_guaranteed` parameter can't be lower than `memory` parameter. Default value is set by engine.
| memory_max - |  | Upper bound of virtual machine memory up to which memory hot-plug can be performed. Prefix uses IEC 60027-2 standard (for example 1GiB, 1024MiB). Default value is set by engine.
| nics - |  | List of NICs, which should be attached to Virtual Machine. NIC is described by following dictionary. `name` - Name of the NIC. `profile_name` - Profile name where NIC should be attached. `interface` - Type of the network interface. One of following virtio, e1000, rtl8139, default is virtio. `mac_address` - Custom MAC address of the network interface, by default it's obtained from MAC pool. NOTE - This parameter is used only when `state` is running or present and is able to only create NICs. To manage NICs of the VM in more depth please use ovirt_nics module instead.
| smartcard_enabled boolean | Choices: no yes | If true, use smart card authentication.
| sso boolean | Choices: no yes | True enable Single Sign On by Guest Agent, False to disable it. By default is chosen by oVirt/RHV engine.
| timezone - |  | Sets time zone offset of the guest hardware clock. For example `Etc/GMT`
vm_count - |  | Number of VMs in the pool. Default value is set by engine.
vm_per_user - |  | Maximum number of VMs a single user can attach to from this pool. Default value is set by engine.
wait boolean | Choices: no yes ← | `yes` if the module should wait for the entity to get into desired state.

## Notes

Note

- In order to use this module you have to install oVirt Python SDK. To ensure it’s installed with correct version you can create the following task: pip: name=ovirt-engine-sdk-python version=4.3.0

## Examples

    # Examples don't contain auth parameter for simplicity,
    # look at ovirt_auth module to see how to reuse authentication:

    - name: Create VM pool from template
      ovirt_vmpool:
        cluster: mycluster
        name: myvmpool
        template: rhel7
        vm_count: 2
        prestarted: 2
        vm_per_user: 1

    - name: Remove vmpool, note that all VMs in pool will be stopped and removed
      ovirt_vmpool:
        state: absent
        name: myvmpool

    - name: Change Pool Name
      ovirt_vmpool:
        id: 00000000-0000-0000-0000-000000000000
        name: "new_pool_name"

    - name: Create vm pool and override the pool values
      ovirt_vmpool:
        cluster: mycluster
        name: vmpool
        template: blank
        vm_count: 2
        prestarted: 1
        vm_per_user: 1
        vm:
          memory: 4GiB
          memory_guaranteed: 4GiB
          memory_max: 10GiB
          comment: vncomment
          cloud_init:
            nic_boot_protocol: static
            nic_ip_address: 10.34.60.86
            nic_netmask: 255.255.252.0
            nic_gateway: 10.34.63.254
            nic_name: eth1
            nic_on_boot: true
            host_name: example.com
            custom_script: |
              write_files:
               - content: |
                   Hello, world!
                 path: /tmp/greeting.txt
                 permissions: '0644'
            user_name: root
            root_password: super_password
          nics:
            - name: nicname
              interface: virtio
              profile_name: network

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
id string | On success if VM pool is found. | ID of the VM pool which is managed Sample: 7de90f31-222c-436c-a1ca-7e655bd5b60c
vm_pool dictionary | On success if VM pool is found. | Dictionary of all the VM pool attributes. VM pool attributes can be found on your oVirt/RHV instance at following url: http://ovirt.github.io/ovirt-engine-api-model/master/#types/vm_pool.

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Ondra Machacek (@machacekondra)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.